Skip to content

# Directory

The tool to check the availability or syntax of domain, IP or URL.

::

    ██████╗ ██╗   ██╗███████╗██╗   ██╗███╗   ██╗ ██████╗███████╗██████╗ ██╗     ███████╗
    ██╔══██╗╚██╗ ██╔╝██╔════╝██║   ██║████╗  ██║██╔════╝██╔════╝██╔══██╗██║     ██╔════╝
    ██████╔╝ ╚████╔╝ █████╗  ██║   ██║██╔██╗ ██║██║     █████╗  ██████╔╝██║     █████╗
    ██╔═══╝   ╚██╔╝  ██╔══╝  ██║   ██║██║╚██╗██║██║     ██╔══╝  ██╔══██╗██║     ██╔══╝
    ██║        ██║   ██║     ╚██████╔╝██║ ╚████║╚██████╗███████╗██████╔╝███████╗███████╗
    ╚═╝        ╚═╝   ╚═╝      ╚═════╝ ╚═╝  ╚═══╝ ╚═════╝╚══════╝╚═════╝ ╚══════╝╚══════╝

Provides the directory helpers.

Author: Nissar Chababy, @funilrys, contactTATAfunilrysTODTODcom

Special thanks: https://pyfunceble.github.io/#/special-thanks

Contributors: https://pyfunceble.github.io/#/contributors

Project link: https://github.com/funilrys/PyFunceble

Project documentation: https://docs.pyfunceble.com

Project homepage: https://pyfunceble.github.io/

License: ::

    Copyright 2017, 2018, 2019, 2020, 2022, 2023, 2024 Nissar Chababy

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        https://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

## `DirectoryHelper`

Simplify the directories manipulation.

Source code in `PyFunceble/helpers/directory.py`

     60
     61
     62
     63
     64
     65
     66
     67
     68
     69
     70
     71
     72
     73
     74
     75
     76
     77
     78
     79
     80
     81
     82
     83
     84
     85
     86
     87
     88
     89
     90
     91
     92
     93
     94
     95
     96
     97
     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200

    class DirectoryHelper:
        """
        Simplify the directories manipulation.

        :param str dir_path the path to work with.
        """

        _path: Optional[str] = None

        def __init__(self, path: Optional[str] = None) -> None:
            if path is not None:
                self.path = path

        @property
        def path(self) -> Optional[str]:
            """
            Provides the current state of the :code:`_path` attribute.
            """

            return self._path

        @path.setter
        def path(self, value: str) -> None:
            """
            Sets the directory path to work with.

            :param value:
                The path to set.

            :raise TypeError:
                When :code:`value` is not a :py:class:`str`.
            """

            if not isinstance(value, str):
                raise TypeError(f"<value> should be {str}, {type(value)} given.")

            self._path = value

        def set_path(self, value: str) -> "DirectoryHelper":
            """
            Sets the directory path to work with.

            :param value:
                The path to set.
            """

            self.path = value

            return self

        @staticmethod
        def get_current(*, with_end_sep: bool = False) -> str:
            """
            Returns the current directory path.

            :param bool with_end_sep:
                Add a directory separator at the end.
            """

            if with_end_sep:
                return os.getcwd() + os.sep
            return os.getcwd()

        @property
        def realpath(self) -> str:
            """
            Returns the real path of the current path.
            """

            return os.path.realpath(self.path)

        def join_path(self, *args) -> str:
            """
            Joins the given arguments with the given path.
            """

            return os.path.join(self.path, *args)

        def exists(self) -> bool:
            """
            Checks if the given directory exists.
            """

            return os.path.isdir(self.path)

        def create(self) -> "DirectoryHelper":
            """
            Creates the given directory path.

            :return: The output of :code:`self.exists` after the directory creation.
            """

            if self.path and not self.exists():
                os.makedirs(self.path, exist_ok=True)

            return self

        def delete(self) -> "DirectoryHelper":
            """
            Deletes the given directory path.

            :return: :code:`not self.exists` after the directory deletion.
            """

            if self.exists():
                shutil.rmtree(self.path)

            return self

        def list_all_subdirectories(self) -> List[str]:
            """
            Provides the list of all subdirectories of the current path.
            """

            result = []

            if self.exists():
                for root, directories, _ in os.walk(self.path):
                    for directory in directories:
                        result.append(os.path.join(root, directory))

            return ListHelper(result).remove_duplicates().sort().subject

        def list_all_files(self) -> List[str]:
            """
            Lists all files of the current path.
            """

            result = []

            if self.exists():
                for directory in self.list_all_subdirectories():
                    for element in os.listdir(directory):
                        possible_element = os.path.join(directory, element)

                        if not os.path.isfile(possible_element):
                            continue

                        result.append(possible_element)

            return ListHelper(result).sort().subject

### `path: Optional[str]` `property` `writable`

Provides the current state of the :code:`_path` attribute.

### `realpath: str` `property`

Returns the real path of the current path.

### `create()`

Creates the given directory path.

Returns:

Type | Description
--- | ---
`DirectoryHelper` | The output of :code:`self.exists` after the directory creation.

Source code in `PyFunceble/helpers/directory.py`

    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155

    def create(self) -> "DirectoryHelper":
        """
        Creates the given directory path.

        :return: The output of :code:`self.exists` after the directory creation.
        """

        if self.path and not self.exists():
            os.makedirs(self.path, exist_ok=True)

        return self

### `delete()`

Deletes the given directory path.

Returns:

Type | Description
--- | ---
`DirectoryHelper` | :code:`not self.exists` after the directory deletion.

Source code in `PyFunceble/helpers/directory.py`

    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167

    def delete(self) -> "DirectoryHelper":
        """
        Deletes the given directory path.

        :return: :code:`not self.exists` after the directory deletion.
        """

        if self.exists():
            shutil.rmtree(self.path)

        return self

### `exists()`

Checks if the given directory exists.

Source code in `PyFunceble/helpers/directory.py`

    138
    139
    140
    141
    142
    143

    def exists(self) -> bool:
        """
        Checks if the given directory exists.
        """

        return os.path.isdir(self.path)

### `get_current(*, with_end_sep=False)` `staticmethod`

Returns the current directory path.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`with_end_sep` | `bool` | Add a directory separator at the end. | `False`

Source code in `PyFunceble/helpers/directory.py`

    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121

    @staticmethod
    def get_current(*, with_end_sep: bool = False) -> str:
        """
        Returns the current directory path.

        :param bool with_end_sep:
            Add a directory separator at the end.
        """

        if with_end_sep:
            return os.getcwd() + os.sep
        return os.getcwd()

### `join_path(*args)`

Joins the given arguments with the given path.

Source code in `PyFunceble/helpers/directory.py`

    131
    132
    133
    134
    135
    136

    def join_path(self, *args) -> str:
        """
        Joins the given arguments with the given path.
        """

        return os.path.join(self.path, *args)

### `list_all_files()`

Lists all files of the current path.

Source code in `PyFunceble/helpers/directory.py`

    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200

    def list_all_files(self) -> List[str]:
        """
        Lists all files of the current path.
        """

        result = []

        if self.exists():
            for directory in self.list_all_subdirectories():
                for element in os.listdir(directory):
                    possible_element = os.path.join(directory, element)

                    if not os.path.isfile(possible_element):
                        continue

                    result.append(possible_element)

        return ListHelper(result).sort().subject

### `list_all_subdirectories()`

Provides the list of all subdirectories of the current path.

Source code in `PyFunceble/helpers/directory.py`

    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181

    def list_all_subdirectories(self) -> List[str]:
        """
        Provides the list of all subdirectories of the current path.
        """

        result = []

        if self.exists():
            for root, directories, _ in os.walk(self.path):
                for directory in directories:
                    result.append(os.path.join(root, directory))

        return ListHelper(result).remove_duplicates().sort().subject

### `set_path(value)`

Sets the directory path to work with.

Parameters:

Name | Type | Description | Default
--- | --- | --- | ---
`value` | `str` | The path to set. | required

Source code in `PyFunceble/helpers/directory.py`

     98
     99
    100
    101
    102
    103
    104
    105
    106
    107
    108

    def set_path(self, value: str) -> "DirectoryHelper":
        """
        Sets the directory path to work with.

        :param value:
            The path to set.
        """

        self.path = value

        return self